#!/usr/bin/fish

function preview -d "Preview any kind of file"

    command kitty +kitten  icat --clear --transfer-mode file

    set c (curpos)

    echo $c
    switch $argv
        case "*.md"
            mdcat $argv
        # case "*.plist"
            # plutil -p $argv
        case "*"
            set bat_args --color always
            set mime (file -b --mime-type $argv)

            switch $mime[1]
                case "text/*"
                    bat $bat_args $argv
                case application/json
                    bat $bat_args -l json $argv
                case image/{gif,jpeg,png,svg+xml,webp}
                    # timg -p kitty -g (math $COLUMNS - 2)x$LINES $argv
                    kitty +kitten icat --transfer-mode file --place (math -s0 $COLUMNS)x(math -s0 $LINES /2 )@(math $COLUMNS + 4)x(math -s0 $LINES /2) --scale-up $argv
                    # echo hi
                # case application/{msword,vnd.{ms-excel,ms-powerpoint,openxmlformats-officedocument.{presentationml.presentation,spreadsheetml.sheet,wordprocessingml.document}},pdf} image/{heic,x-icns} video/{mp4,x-matroska}
                    # set tmp (mktemp -d)
                    # qlmanage -t -s (math $COLUMNS x 8) -o $tmp $argv &>/dev/null
                    # preview $tmp/*
                    # rm -r $tmp
                case application/{gzip,java-archive,x-{7z-compressed,bzip2,chrome-extension,rar,tar,xar},zip}
                    7z l $argv | tail -n +12
                case "*"
                    file -b $argv
                    echo "($mime[1])"
            end
    end

end